#include "d_win32.h"

static int winthread(void *dmy)
{
	WNDCLASSEX wc;
	RECT r;
	unsigned char *p, *p0, *p00;
	static unsigned char t[32];
	int i, x, y;
	MSG msg;

	x = dw.bmi.bmiHeader.biWidth;
	y = - dw.bmi.bmiHeader.biHeight;

	wc.cbSize = sizeof (WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = dw.hi;
	wc.hIcon = (HICON) LoadImage(NULL, MAKEINTRESOURCE(IDI_APPLICATION),
		IMAGE_ICON, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	wc.hIconSm = wc.hIcon;
	wc.hCursor = (HCURSOR)LoadImage(NULL, MAKEINTRESOURCE(IDC_ARROW),
		IMAGE_CURSOR, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	wc.hbrBackground = (HBRUSH) COLOR_APPWORKSPACE;
	wc.lpszMenuName = NULL;
	wc.lpszClassName = "WinClass";
	if (RegisterClassEx(&wc) == 0)
		return 1;
	r.left = 0;
	r.top = 0;
	r.right = x;
	r.bottom = y;
	AdjustWindowRect(&r, WS_OVERLAPPEDWINDOW, FALSE);
	x = r.right - r.left;
	y = r.bottom - r.top;

	p00 = p0 = p = GetCommandLineA();
	if (*p == 0x22) {
		p00 = p0 = ++p;
		while (*p != '\0' && *p != 0x22) {
			if (*p == '\\')
				p0 = p + 1;
			p++;
		}
	} else {
		while (*p > ' ') {
			if (*p == '\\')
				p0 = p + 1;
			p++;
		}
	}
	if (p - p0 > 4 && p[-4] == '.' && p[-3] == 'e' && p[-2] == 'x' && p[-1] == 'e')
		p -= 4;
	for (i = 0; i < 32 - 1; i++) {
		if (p <= &p0[i])
			break;
		t[i] = p0[i];
	}
	t[i] = '\0';

	dw.hw = CreateWindowA(wc.lpszClassName, t, WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, x, y, NULL, NULL,	dw.hi, NULL);
	if (dw.hw == NULL)
		return 1;
	ShowWindow(dw.hw, SW_SHOW);
	UpdateWindow(dw.hw);
	SetTimer(dw.hw, TIMER_ID,     TIMER_INTERVAL,       NULL);
	SetTimer(dw.hw, TIMER_ID + 1, TIMER_INTERVAL * 10,  NULL);
	SetTimer(dw.hw, TIMER_ID + 2, TIMER_INTERVAL * 100, NULL);
	dw.flags |= 2 | 4;

	for (;;) {
		i = GetMessage(&msg, NULL, 0, 0);
		if (i == 0 || i == -1)	/* G[͏IbZ[W */
			break;
		/* ̂ق͂Ƃ肠ftHg */
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
//	PostQuitMessage(0);
	dw.flags |= 1; /* I, bld_waitNF() */
	return 0;
}

void bld_openWin(int sx, int sy)
{
	static int i;

	dw.bmi.bmiHeader.biSize = sizeof (BITMAPINFOHEADER);
	dw.bmi.bmiHeader.biWidth = sx;
	dw.bmi.bmiHeader.biHeight = - sy;
	dw.bmi.bmiHeader.biPlanes = 1;
	dw.bmi.bmiHeader.biBitCount = 32;
	dw.bmi.bmiHeader.biCompression = BI_RGB;

	CreateThread(NULL, 0, winthread, NULL, 0, &i);

	return;
}

void bld_flshWin(int sx, int sy, int x0, int y0)
{
	RECT rect;
	rect.left = x0;
	rect.top = y0;
	rect.right = x0 + sx; /* RECTł-1Ă͂Ȃ悤 */
	rect.bottom = y0 + sy; /* RECTł-1Ă͂Ȃ悤 */
	if (dw.hw != NULL) {
//		InvalidateRect(dw.hw, &rect, FALSE);
		dw.flags |= 2;	/* bld_waitNFŎQƁNA */
	}
	return;
}

LRESULT CALLBACK WndProc(HWND hw, unsigned int msg, WPARAM wp, LPARAM lp)
{
	int i;
	if (msg == WM_PAINT) {
		PAINTSTRUCT ps;
		HDC hdc = BeginPaint(dw.hw, &ps);
		SetDIBitsToDevice(hdc, 0, 0, w.win[BL_SYSWIN].xsiz, w.win[BL_SYSWIN].ysiz,
			0, 0, 0, w.win[BL_SYSWIN].ysiz, w.win[BL_SYSWIN].buf, &dw.bmi, DIB_RGB_COLORS);
		EndPaint(dw.hw, &ps);
	}
	if (msg == WM_DESTROY) {
		PostQuitMessage(0);
		return 0;
	}
	if (msg == WM_TIMER && wp == TIMER_ID) {
		w.tmcount += TIMER_INTERVAL;
		return 0;
	}
	if (msg == WM_TIMER && wp == TIMER_ID + 1) {
		dw.tmcount1 += TIMER_INTERVAL * 10;
		w.tmcount = dw.tmcount1;
		return 0;
	}
	if (msg == WM_TIMER && wp == TIMER_ID + 2) {
		dw.tmcount2 += TIMER_INTERVAL * 100;
		w.tmcount = dw.tmcount1 = dw.tmcount2;
		return 0;
	}
	if (msg == WM_KEYDOWN) {
		i = 0;
#if 0
		int s_sht = GetKeyState(VK_SHIFT);
		int s_ctl = GetKeyState(VK_CONTROL);
		int s_cap = GetKeyState(VK_CAPITAL);
		int s_num = GetKeyState(VK_NUMLOCK);
		if ('A' <= wp && wp <= 'Z') {
			i = wp;
			if (((s_sht < 0) ^ (s_cap & 1)) == 0)
				i += 'a' - 'A';
		}
		if (wp == VK_SPACE)		i = ' ';
#endif
		if (wp == VK_RETURN)	i = KEY_ENTER;
		if (wp == VK_ESCAPE)	i = KEY_ESC;
		if (wp == VK_BACK)		i = KEY_BACKSPACE;
		if (wp == VK_TAB)		i = KEY_TAB;
		if (wp == VK_LEFT)		i = KEY_LEFT;
		if (wp == VK_RIGHT)		i = KEY_RIGHT;
		if (wp == VK_UP)		i = KEY_UP;
		if (wp == VK_DOWN)		i = KEY_DOWN;
		if (wp == VK_INSERT)	i = KEY_INS;
		if (wp == VK_DELETE)	i = KEY_DEL;
		if (i != 0) {
			bl_putKeyB(1, &i);
			return 0;
		}
	}
	if (msg == WM_KEYUP) {
		i = 0xfff;
		bl_putKeyB(1, &i);
	}
	if (msg == WM_CHAR) {
		i = 0;
		if (' ' <= wp && wp <= 0x7e) {
			i = wp;
			bl_putKeyB(1, &i);
			return 0;
		}
	}
	return DefWindowProc(hw, msg, wp, lp);
}
