#include "d_win32.h"

struct BLD_WORK bld_work;

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, PSTR pCmdLine, int showCmd)
{
	int i;
	dw.hi = hInst;
	dw.tmcount1 = dw.tmcount2 = dw.smp = 0;
	dw.flags = 0;
//	dw.mtx = CreateMutex(NULL, FALSE, NULL);
	i = bl_main();
	PostQuitMessage(0);
	if ((dw.flags & 4) != 0) {
		KillTimer(dw.hw, TIMER_ID);
		KillTimer(dw.hw, TIMER_ID + 1);
		KillTimer(dw.hw, TIMER_ID + 2);
	}
	return i;
}

void *bld_malloc(unsigned int bytes)
{
	return malloc(bytes);
}

void bld_free(void *p, unsigned int bytes)
{
	free(p);
	return;
}

int bld_maxfonts()
{
	return 65536 * 4;	/* b */
}

int bld_xchg(int *p, int i);

void bld_lock()
{
	int i;
	do {
		i = bld_xchg(&dw.smp, 1);
	} while (i != 0);
	return;
}

void bld_unlock()
{
	dw.smp = 0;
	return;
}


#if 0

static int xchg(int *p, int i)
{
	int r;
	__asm__ __volatile__("xchgl %%eax,(%%ecx)\n":"=a"(r):"a"(i),"c"(p):"memory");
	return r;
}

void bld_lock()
{
	WaitForSingleObject(dw.mtx, INFINITE);
	return;
}

void bld_unlock()
{
	ReleaseMutex(dw.mtx);
	return;
}

#endif

